NOEMIT witness_dissect_element_interfaceInfo_group_name
MANUAL witness_dissect_element_ResourceChange_type
MANUAL witness_dissect_element_ResourceChange_name
MANUAL witness_dissect_struct_notifyResponse
NOEMIT witness_dissect_element_notifyResponse_messages
MANUAL witness_dissect_struct_IPaddrInfoList
NOEMIT witness_dissect_struct_IPaddrInfoList
NOEMIT witness_dissect_element_IPaddrInfoList_num
NOEMIT witness_dissect_element_IPaddrInfoList_addr

MANUAL witness_dissect_enum_interfaceInfo_state
MANUAL witness_dissect_bitmap_interfaceInfo_flags

NOEMIT witness_dissect_element_notifyResponse_type
NOEMIT witness_dissect_element_notifyResponse_num

MANUAL witness_dissect_element_Register_net_name_
MANUAL witness_dissect_element_Register_ip_address_

MANUAL witness_dissect_element_RegisterEx_net_name_
MANUAL witness_dissect_element_RegisterEx_share_name_
MANUAL witness_dissect_element_RegisterEx_ip_address_

HF_FIELD hf_witness_witness_notifyResponse_messages_ "Messages" "witness.witness_notifyResponse.messages_" FT_NONE BASE_NONE NULL 0 "" "" ""

TYPE ipv4address "offset=PIDL_dissect_ipv4address(tvb, offset, pinfo, tree, di, drep, @HF@, PIDL_SET_COL_INFO);" FT_IPv4 BASE_NONE 0 NULL 4

TYPE ipv6address "offset=PIDL_dissect_ipv6address(tvb, offset, pinfo, tree, di, drep, @HF@, PIDL_SET_COL_INFO);" FT_IPv6 BASE_NONE 0 NULL 2

CODE START

 #include "to_str.h"
 #include "wsutil/str_util.h"

static int
witness_dissect_element_ResourceChange_type(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_)
{
	proto_item *item = NULL;
	const char *s = NULL;
	int levels = 2;
	uint32_t type = 0;
	static const value_string type_vals[] = {
		{ WITNESS_RESOURCE_STATE_UNKNOWN, "RESOURCE_STATE_UNKNOWN" },
		{ WITNESS_RESOURCE_STATE_AVAILABLE, "RESOURCE_AVAILABLE" },
		{ WITNESS_RESOURCE_STATE_UNAVAILABLE, "RESOURCE_UNAVAILABLE" },
		{ 0, NULL }
	};

	offset = witness_dissect_enum_ResourceChange_type(tvb, offset, pinfo, tree, di, drep, hf_witness_witness_ResourceChange_type, &type);

	s = val_to_str_wmem(pinfo->pool, type, VALS(type_vals), "unknown type: 0x%x");

	if (di->conformant_run == 0) {
		col_append_fstr(pinfo->cinfo, COL_INFO, ", %s", s);
	}

	if (tree != NULL) {
		item = tree->last_child;
	}

	item = proto_item_get_parent(item);
	while (item && levels > 0) {
		proto_item_append_text(item, " %s", s);
		item = proto_item_get_parent(item);
		levels--;
	}

	return offset;
}

static int
witness_dissect_element_ResourceChange_name(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_)
{
	int options = CB_STR_COL_INFO | CB_STR_ITEM_LEVELS(2);

	offset = dissect_null_term_wstring(tvb, offset, pinfo, tree, drep, hf_witness_witness_ResourceChange_name, options);

	return offset;
}

static int
witness_dissect_notifyResponse_message(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *parent_tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_, int hf_index _U_, uint32_t param _U_);

struct witness_dissect_notifyResponse_message_state {
	uint64_t magic1;
	uint32_t type;
	uint32_t num;
	uint64_t magic2;
};

#include <wsutil/ws_assert.h>

static int
witness_dissect_notifyResponse_message_(tvbuff_t *tvb, int offset, int length _U_, packet_info *pinfo,
				        proto_tree *tree, dcerpc_info *p_di, uint8_t *p_drep _U_)
{
	const struct witness_dissect_notifyResponse_message_state *state =
		(const struct witness_dissect_notifyResponse_message_state *)p_di->private_data;
	uint8_t le_drep[4] = { DREP_LITTLE_ENDIAN, };
	static dcerpc_info di = {0, };      /* fake dcerpc_info struct */
	static dcerpc_call_value call_data = { 0, };
	tvbuff_t *subtvb = tvb_new_subset_length(tvb, offset, length);
	int suboffset = 0;
	uint32_t i;

	ws_assert(state->magic1 == 0x0123456789ABCDEF);
	ws_assert(state->magic2 == 0xFEDCBA9876543210);

	/* fake whatever state the dcerpc runtime support needs */
	di.conformant_run=0;
	/* we need di->call_data->flags.NDR64 == 0 */
	di.call_data=&call_data;
	init_ndr_pointer_list(&di);

	for (i=0; i < state->num; i++) {
		suboffset = witness_dissect_notifyResponse_message(subtvb, suboffset, pinfo, tree, &di, le_drep,
						      hf_witness_witness_notifyResponse_messages_, state->type);
	}

	free_ndr_pointer_list(&di);
	return offset + suboffset;
}

static int
witness_dissect_element_notifyResponse_messages(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *tree _U_, dcerpc_info *di _U_, uint8_t *drep _U_)
{
	offset = dissect_ndr_ucarray_block(tvb, offset, pinfo, tree, di, drep,
					   witness_dissect_notifyResponse_message_);
	return offset;
}

static int
witness_dissect_element_notifyResponse_type(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_, uint32_t *type)
{
	offset = witness_dissect_enum_notifyResponse_type(tvb, offset, pinfo, tree, di, drep, hf_witness_witness_notifyResponse_type, type);

	return offset;
}

static int
witness_dissect_element_notifyResponse_num(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_, uint32_t *num)
{
	offset = PIDL_dissect_uint32_val(tvb, offset, pinfo, tree, di, drep, hf_witness_witness_notifyResponse_num, 0, num);

	return offset;
}

int
witness_dissect_struct_notifyResponse(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *parent_tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_, int hf_index _U_, uint32_t param _U_)
{
	proto_item *item = NULL;
	proto_tree *tree = NULL;
	int old_offset;
	struct witness_dissect_notifyResponse_message_state *state = NULL;
	const char *type_name = "UNKNOWN";

	ALIGN_TO_4_BYTES;

	old_offset = offset;

	if (parent_tree) {
		item = proto_tree_add_item(parent_tree, hf_index, tvb, offset, -1, ENC_NA);
		tree = proto_item_add_subtree(item, ett_witness_witness_notifyResponse);
	}

	state = wmem_new0(pinfo->pool, struct witness_dissect_notifyResponse_message_state);
	state->magic1 = 0x0123456789ABCDEF;
	state->magic2 = 0xFEDCBA9876543210;
	offset = witness_dissect_element_notifyResponse_type(tvb, offset, pinfo, tree, di, drep, &state->type);

	offset = witness_dissect_element_notifyResponse_length(tvb, offset, pinfo, tree, di, drep);

	offset = witness_dissect_element_notifyResponse_num(tvb, offset, pinfo, tree, di, drep, &state->num);

	switch(state->type) {
	case WITNESS_NOTIFY_RESOURCE_CHANGE:
		type_name = "RESOURCE_CHANGE";
		break;

	case WITNESS_NOTIFY_CLIENT_MOVE:
		type_name = "CLIENT_MOVE";
		break;

	case WITNESS_NOTIFY_SHARE_MOVE:
		type_name = "SHARE_MOVE";
		break;

	case WITNESS_NOTIFY_IP_CHANGE:
		type_name = "IP_CHANGE";
		break;
	}

	if (item) {
		proto_item_append_text(item,
				       " %s (%u message%s)",
				       type_name,
				       state->num,
				       plurality(state->num, "", "s"));
		proto_item_append_text(proto_item_get_parent_nth(item, 1),
				       " %s (%u message%s)",
				       type_name,
				       state->num,
				       plurality(state->num, "", "s"));
		proto_item_append_text(proto_item_get_parent_nth(item, 2),
				       " %s (%u message%s)",
				       type_name,
				       state->num,
				       plurality(state->num, "", "s"));
		proto_item_append_text(proto_item_get_parent_nth(item, 3),
				       " %s (%u message%s)",
				       type_name,
				       state->num,
				       plurality(state->num, "", "s"));
	}
	if (di->conformant_run == 0) {
		col_append_fstr(pinfo->cinfo, COL_INFO,
				" %s (%u message%s)",
				type_name,
				state->num,
				plurality(state->num, "", "s"));
	}

	di->private_data = state;
	offset = dissect_ndr_embedded_pointer(tvb, offset, pinfo, tree, di, drep,
					      witness_dissect_element_notifyResponse_messages,
					      NDR_POINTER_UNIQUE, "Pointer to Message Buffer (uint8)",
					      hf_witness_witness_notifyResponse_messages);

	proto_item_set_len(item, offset-old_offset);

	if (di->call_data->flags & DCERPC_IS_NDR64) {
		ALIGN_TO_4_BYTES;
	}

	return offset;
}

static int
witness_dissect_element_IPaddrInfoList_num(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_, uint32_t *num)
{
	offset = PIDL_dissect_uint32_val(tvb, offset, pinfo, tree, di, drep, hf_witness_witness_IPaddrInfoList_num, 0, num);

	return offset;
}

static int
witness_dissect_element_IPaddrInfoList_addr(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_)
{
	offset = witness_dissect_struct_IPaddrInfo(tvb,offset,pinfo,tree,di,drep,hf_witness_witness_IPaddrInfoList_addr,0);

	return offset;
}

int
witness_dissect_struct_IPaddrInfoList(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *parent_tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_, int hf_index _U_, uint32_t param _U_)
{
	proto_item *item = NULL;
	proto_tree *tree = NULL;
	bool oldalign = di->no_align;
	int old_offset;
	uint32_t i, num;

	di->no_align = true;

	old_offset = offset;

	if (parent_tree) {
		item = proto_tree_add_item(parent_tree, hf_index, tvb, offset, -1, ENC_NA);
		tree = proto_item_add_subtree(item, ett_witness_witness_IPaddrInfoList);
	}

	offset = witness_dissect_element_IPaddrInfoList_length(tvb, offset, pinfo, tree, di, drep);

	offset = witness_dissect_element_IPaddrInfoList_reserved(tvb, offset, pinfo, tree, di, drep);

	offset = witness_dissect_element_IPaddrInfoList_num(tvb, offset, pinfo, tree, di, drep, &num);

	for (i = 0; i < num; i++) {
		offset = witness_dissect_element_IPaddrInfoList_addr(tvb, offset, pinfo, tree, di, drep);
	}

	proto_item_set_len(item, offset-old_offset);

	di->no_align = oldalign;

	return offset;
}

static int
witness_dissect_element_interfaceInfo_group_name(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *parent_tree, dcerpc_info *di _U_, uint8_t *drep _U_)
{
	int totlen, stringlen;
	char *str;
	proto_item *pi;

	/*
	 * XXX - this is described as
	 *
	 *    [charset(UTF16),to_null] uint16 group_name[260];
	 *
	 * I haven't found any documentation for what "to_null" means
	 * in PIDL; is this a null-padded 260*2-byte array, so that
	 * strings can be up to 260 16-bit units in length, or is
	 * it a null-*terminated* string, so that it can be up to 259
	 * 16-bit units in length?
	 *
	 * We assume it's null-padded, for now, and scan for a 2-byte
	 * null terminator within the 260 2-byte units, and use
	 * that as the length, with the length being 2*260 if there
	 * isn't one.
	 *
	 * This will result in totlen being the total length, in
	 * bytes, of the string, including the null terminator, if
	 * present, and stringlen being the total length, in bytes.
	 * not counting any null terminator.
	 */
	totlen = 0;
	stringlen = 0;
	while (totlen < 2*260) {
		/*
		 * These 2 bytes are either part of the string
		 * or part of the null terminator, so count
		 * them.
		 */
		totlen += 2;
		if (tvb_get_letohs(tvb, offset + stringlen) == 0)
			break;
		/*
		 * Those 2 bytes are part of the string, so
		 * count them.
		 */
		stringlen += 2;
	}
	pi = proto_tree_add_item_ret_display_string(parent_tree,
	    hf_witness_witness_interfaceInfo_group_name, tvb, offset, stringlen,
	    ENC_UTF_16|ENC_LITTLE_ENDIAN,
	    pinfo->pool, &str);
	proto_item_append_text(pi, " [%d]", totlen);
	proto_item_append_text(parent_tree, ": %s", str);

	/*
	 * All 260 16-bit units are part of the field, as they're always
	 * there even if they don't need to be.
	 */
	return offset + 2*260;
}

static int
PIDL_dissect_ipv4address(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree, dcerpc_info *di, uint8_t *drep _U_, int hfindex, uint32_t param)
{
	if (di->conformant_run) {
		/* just a run to handle conformant arrays, no scalars to dissect */
		return offset;
	}


	if (!di->no_align && (offset % 4)) {
		offset += 4 - (offset % 4);
	}

	proto_tree_add_item(tree, hfindex, tvb, offset, 4, ENC_BIG_ENDIAN);

	if (param & PIDL_SET_COL_INFO) {
		const char *ip = tvb_ip_to_str(pinfo->pool, tvb, offset);
		header_field_info *hf_info = proto_registrar_get_nth(hfindex);

		if (strcmp(ip, "0.0.0.0") != 0) {
			proto_item_append_text(proto_tree_get_parent(tree), " %s:%s", hf_info->name, ip);

			col_append_fstr(pinfo->cinfo, COL_INFO," %s:%s", hf_info->name, ip);
		}
	}
	return offset + 4;
}

static int
PIDL_dissect_ipv6address(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree, dcerpc_info *di, uint8_t *drep _U_, int hfindex, uint32_t param)
{
	if (di->conformant_run) {
		/* just a run to handle conformant arrays, no scalars to dissect */
		return offset;
	}


	if (!di->no_align && (offset % 2)) {
		offset += 2 - (offset % 2);
	}

	proto_tree_add_item(tree, hfindex, tvb, offset, 16, ENC_BIG_ENDIAN);

	if (param & PIDL_SET_COL_INFO) {
		const char *ip = tvb_ip6_to_str(pinfo->pool, tvb, offset);
		header_field_info *hf_info = proto_registrar_get_nth(hfindex);

		if (strcmp(ip, "::") != 0) {
			proto_item_append_text(proto_tree_get_parent(tree), " %s:%s", hf_info->name, ip);

			col_append_fstr(pinfo->cinfo, COL_INFO," %s:%s", hf_info->name, ip);
		}
	}

	return offset + 16;
}

/* IDL: enum { */
/* IDL: 	WITNESS_STATE_UNKNOWN=0x00, */
/* IDL: 	WITNESS_STATE_AVAILABLE=0x01, */
/* IDL: 	WITNESS_STATE_UNAVAILABLE=0xff, */
/* IDL: } */

int
witness_dissect_enum_interfaceInfo_state(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_, int hf_index _U_, uint16_t *param _U_)
{
	static const value_string state_vals[] = {
		{ WITNESS_STATE_UNKNOWN, "STATE_UNKNOWN" },
		{ WITNESS_STATE_AVAILABLE, "AVAILABLE" },
		{ WITNESS_STATE_UNAVAILABLE, "UNAVAILABLE" },
		{ 0, NULL }
	};
	const char *s = NULL;
	uint16_t parameter=0;
	if (param) {
		parameter = *param;
	}
	offset = dissect_ndr_uint16(tvb, offset, pinfo, tree, di, drep, hf_index, &parameter);
	if (param) {
		*param = parameter;
	}

	s = val_to_str_wmem(pinfo->pool, parameter, VALS(state_vals), "unknown state: 0x%x");

	proto_item_append_text(proto_tree_get_parent(tree), " %s:", s);
	if (di->conformant_run == 0) {
		col_append_fstr(pinfo->cinfo, COL_INFO, ", %s", s);
	}

	return offset;
}


/* IDL: bitmap { */
/* IDL: 	WITNESS_INFO_IPv4_VALID =  0x01 , */
/* IDL: 	WITNESS_INFO_IPv6_VALID =  0x02 , */
/* IDL: 	WITNESS_INFO_WITNESS_IF =  0x04 , */
/* IDL: } */

int
witness_dissect_bitmap_interfaceInfo_flags(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *parent_tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_, int hf_index _U_, uint32_t param _U_)
{
	proto_item *item;
	static int * const witness_witness_interfaceInfo_flags_fields[] = {
		&hf_witness_witness_interfaceInfo_flags_WITNESS_INFO_IPv4_VALID,
		&hf_witness_witness_interfaceInfo_flags_WITNESS_INFO_IPv6_VALID,
		&hf_witness_witness_interfaceInfo_flags_WITNESS_INFO_WITNESS_IF,
		NULL
	};
	uint32_t flags;
	ALIGN_TO_4_BYTES;

	item = proto_tree_add_bitmask_with_flags(parent_tree, tvb, offset, hf_index,
				ett_witness_witness_interfaceInfo_flags, witness_witness_interfaceInfo_flags_fields, DREP_ENC_INTEGER(drep), BMT_NO_FALSE);

	offset = dissect_ndr_uint32(tvb, offset, pinfo, parent_tree, di, drep, -1, &flags);

	if (!flags)
		proto_item_append_text(item, ": (No values set)");

	if (flags & (~0x00000007)) {
		flags &= (~0x00000007);
		proto_item_append_text(item, "Unknown bitmap value 0x%x", flags);
	}

	if (flags & 0x4) {
		proto_item_append_text(proto_tree_get_parent(parent_tree), " WITNESS_IF");
		col_append_fstr(pinfo->cinfo, COL_INFO," WITNESS_IF");
	}

	return offset;
}

static int
witness_dissect_element_Register_net_name_(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_)
{
	char *data = NULL;
	struct ndr_generic_array nga = { .is_conformant = FALSE, };

	offset = dissect_ndr_conformant_array_hdr(tvb, offset, pinfo, tree, di, drep, &nga);

	offset = dissect_ndr_varying_array_hdr(tvb, offset, pinfo, tree, di, drep, &nga);

	offset = dissect_ndr_generic_array_string(tvb, offset, pinfo, tree, di, drep, sizeof(uint16_t), hf_witness_witness_Register_net_name, FALSE, &nga, &data);
	proto_item_append_text(tree, ": %s", data);
	if (di->conformant_run == 0) {
		col_append_fstr(pinfo->cinfo, COL_INFO, " NetName[%s]", data);
	}

	return offset;
}

static int
witness_dissect_element_Register_ip_address_(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_)
{
	char *data = NULL;
	struct ndr_generic_array nga = { .is_conformant = FALSE, };

	offset = dissect_ndr_conformant_array_hdr(tvb, offset, pinfo, tree, di, drep, &nga);

	offset = dissect_ndr_varying_array_hdr(tvb, offset, pinfo, tree, di, drep, &nga);

	offset = dissect_ndr_generic_array_string(tvb, offset, pinfo, tree, di, drep, sizeof(uint16_t), hf_witness_witness_Register_ip_address, FALSE, &nga, &data);
	proto_item_append_text(tree, ": %s", data);
	if (di->conformant_run == 0) {
		col_append_fstr(pinfo->cinfo, COL_INFO, " IpAddress[%s]", data);
	}

	return offset;
}

static int
witness_dissect_element_RegisterEx_net_name_(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_)
{
	char *data = NULL;
	struct ndr_generic_array nga = { .is_conformant = FALSE, };

	offset = dissect_ndr_conformant_array_hdr(tvb, offset, pinfo, tree, di, drep, &nga);

	offset = dissect_ndr_varying_array_hdr(tvb, offset, pinfo, tree, di, drep, &nga);

	offset = dissect_ndr_generic_array_string(tvb, offset, pinfo, tree, di, drep, sizeof(uint16_t), hf_witness_witness_RegisterEx_net_name, FALSE, &nga, &data);
	proto_item_append_text(tree, ": %s", data);
	if (di->conformant_run == 0) {
		col_append_fstr(pinfo->cinfo, COL_INFO, " NetName[%s]", data);
	}

	return offset;
}

static int
witness_dissect_element_RegisterEx_share_name_(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_)
{
	char *data = NULL;
	struct ndr_generic_array nga = { .is_conformant = FALSE, };

	offset = dissect_ndr_conformant_array_hdr(tvb, offset, pinfo, tree, di, drep, &nga);

	offset = dissect_ndr_varying_array_hdr(tvb, offset, pinfo, tree, di, drep, &nga);

	offset = dissect_ndr_generic_array_string(tvb, offset, pinfo, tree, di, drep, sizeof(uint16_t), hf_witness_witness_RegisterEx_share_name, FALSE, &nga, &data);
	proto_item_append_text(tree, ": %s", data);
	if (di->conformant_run == 0) {
		col_append_fstr(pinfo->cinfo, COL_INFO, " ShareName[%s]", data);
	}

	return offset;
}

static int
witness_dissect_element_RegisterEx_ip_address_(tvbuff_t *tvb _U_, int offset _U_, packet_info *pinfo _U_, proto_tree *tree _U_, dcerpc_info* di _U_, uint8_t *drep _U_)
{
	char *data = NULL;
	struct ndr_generic_array nga = { .is_conformant = FALSE, };

	offset = dissect_ndr_conformant_array_hdr(tvb, offset, pinfo, tree, di, drep, &nga);

	offset = dissect_ndr_varying_array_hdr(tvb, offset, pinfo, tree, di, drep, &nga);

	offset = dissect_ndr_generic_array_string(tvb, offset, pinfo, tree, di, drep, sizeof(uint16_t), hf_witness_witness_RegisterEx_ip_address, FALSE, &nga, &data);
	proto_item_append_text(tree, ": %s", data);
	if (di->conformant_run == 0) {
		col_append_fstr(pinfo->cinfo, COL_INFO, " IpAddress[%s]", data);
	}

	return offset;
}

CODE END
